'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var utils = require('@emotion/utils');
var React = require('react');
var createCache = _interopDefault(require('@emotion/cache'));

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

function _render() {
  return React.createElement(CSSContext.Provider, {
    value: this.emotionCache
  }, this.props.children(this.emotionCache));
}

var BasicProvider =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(BasicProvider, _React$Component);

  function BasicProvider(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    _this.emotionCache = createCache();
    return _this;
  }

  var _proto = BasicProvider.prototype;
  _proto.render = _render;
  return BasicProvider;
}(React.Component); // $FlowFixMe


var CSSContext = React.createContext(utils.isBrowser && process.env.NODE_ENV !== 'test' ? createCache() : null);
function withCSSContext(func) {
  return function (props) {
    function _ref(newContext) {
      return func(props, newContext);
    }

    return React.createElement(CSSContext.Consumer, null, function (context) {
      if (context === null) {
        return React.createElement(BasicProvider, null, _ref);
      } else {
        return func(props, context);
      }
    });
  };
}
function consume(func) {
  function _ref2(newContext) {
    return func(newContext);
  }

  return React.createElement(CSSContext.Consumer, null, function (context) {
    if (context === null) {
      return React.createElement(BasicProvider, null, _ref2);
    } else {
      return func(context);
    }
  });
}

exports.CSSContext = CSSContext;
exports.withCSSContext = withCSSContext;
exports.consume = consume;
//# sourceMappingURL=index.cjs.js.map
