import { isBrowser } from '@emotion/utils';
import { createElement, Component, createContext } from 'react';
import createCache from '@emotion/cache';

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

function _render() {
  return createElement(CSSContext.Provider, {
    value: this.emotionCache
  }, this.props.children(this.emotionCache));
}

var BasicProvider =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(BasicProvider, _React$Component);

  function BasicProvider(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    _this.emotionCache = createCache();
    return _this;
  }

  var _proto = BasicProvider.prototype;
  _proto.render = _render;
  return BasicProvider;
}(Component); // $FlowFixMe


var CSSContext = createContext(isBrowser && process.env.NODE_ENV !== 'test' ? createCache() : null);
function withCSSContext(func) {
  return function (props) {
    function _ref(newContext) {
      return func(props, newContext);
    }

    return createElement(CSSContext.Consumer, null, function (context) {
      if (context === null) {
        return createElement(BasicProvider, null, _ref);
      } else {
        return func(props, context);
      }
    });
  };
}
function consume(func) {
  function _ref2(newContext) {
    return func(newContext);
  }

  return createElement(CSSContext.Consumer, null, function (context) {
    if (context === null) {
      return createElement(BasicProvider, null, _ref2);
    } else {
      return func(context);
    }
  });
}

export { CSSContext, withCSSContext, consume };
//# sourceMappingURL=index.es.js.map
